#pragma once
#ifndef ANALIZADOR_H
#define ANALIZADOR_H

#include "utils.h"

typedef struct {

    PBYTE original;
    PBYTE buffer;
    SIZE_T tamano;
    SIZE_T tamanoOriginal;

} Analizador, * PAnalizador;

PAnalizador nuevoAnalizador(PBYTE buffer, SIZE_T tamano);
VOID liberarAnalizador(PAnalizador analizador);

BYTE getByte(PAnalizador analizador);
UINT32 getInt32(PAnalizador analizador);
UINT64 getInt64(PAnalizador analizador);
PBYTE getBytes(PAnalizador analizador, PSIZE_T tamano);
PCHAR getString(PAnalizador analizador, PSIZE_T tamano);
PWCHAR getWString(PAnalizador analizador, PSIZE_T tamano);

#endif